-- 10bit Qam-16 I & Q Decoder

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY ten_bit_IQdec IS 

	PORT(I_Din :IN  STD_LOGIC_VECTOR(9 DOWNTO 0);
		 Q_Din :IN  STD_LOGIC_VECTOR(9 DOWNTO 0);
		 Clk :IN STD_LOGIC;
		 Dout:OUT STD_LOGIC_VECTOR(3 DOWNTO 0));
		 
END ten_bit_IQdec;

ARCHITECTURE LogicFunction OF ten_bit_IQdec IS
	
	SIGNAL Dbuff:STD_LOGIC_VECTOR(3 DOWNTO 0);
	
BEGIN
	
	PROCESS(I_Din, Q_Din)
		BEGIN
			IF 	  ((I_Din >= "1011111011")AND(Q_Din <= "1111110100")AND(I_Din >= "0000001100")AND(I_Din <= "0100000110")) THEN
				Dbuff <= "0000";
			ELSIF ((I_Din >= "1000000001")AND(Q_Din <= "1011111010")AND(I_Din >= "0000001100")AND(I_Din <= "0100000110")) THEN
				Dbuff <= "0001";
			ELSIF ((Q_Din >= "0000001100")AND(Q_Din <= "0100000110")AND(I_Din >= "0000001100")AND(I_Din <= "0100000110")) THEN
				Dbuff <= "0010";
			ELSIF ((Q_Din >= "0100000111")AND(Q_Din <= "1000000000")AND(I_Din >= "0000001100")AND(I_Din <= "0100000110")) THEN
				Dbuff <= "0011";
			ELSIF ((Q_Din >= "1011111011")AND(Q_Din <= "1111110100")AND(I_Din >= "0100000111")AND(I_Din <= "1000000000")) THEN
				Dbuff <= "0100";
			ELSIF ((Q_Din >= "1000000001")AND(Q_Din <= "1011111010")AND(I_Din >= "0100000111")AND(I_Din <= "1000000000")) THEN
				Dbuff <= "0101";
			ELSIF ((Q_Din >= "0000001100")AND(Q_Din <= "0100000110")AND(I_Din >= "0100000111")AND(I_Din <= "1000000000")) THEN
				Dbuff <= "0110";
			ELSIF ((Q_Din >= "0100000111")AND(Q_Din <= "1000000000")AND(I_Din >= "0100000111")AND(I_Din <= "1000000000")) THEN
				Dbuff <= "0111";
			ELSIF ((Q_Din >= "1011111011")AND(Q_Din <= "1111110100")AND(I_Din >= "1011111011")AND(I_Din <= "1111110100")) THEN
				Dbuff <= "1000";
			ELSIF ((Q_Din >= "1000000001")AND(Q_Din <= "1011111010")AND(I_Din >= "1011111011")AND(I_Din <= "1111110100")) THEN
				Dbuff <= "1001";
			ELSIF ((Q_Din >= "0000001100")AND(Q_Din <= "0100000110")AND(I_Din >= "1011111011")AND(I_Din <= "1111110100")) THEN
				Dbuff <= "1010";
			ELSIF ((Q_Din >= "0100000111")AND(Q_Din <= "1000000000")AND(I_Din >= "1011111011")AND(I_Din <= "1111110100")) THEN
				Dbuff <= "1011";
			ELSIF ((Q_Din >= "1011111011")AND(Q_Din <= "1111110100")AND(I_Din >= "1000000001")AND(I_Din <= "1011111010")) THEN
				Dbuff <= "1100";
			ELSIF ((Q_Din >= "1000000001")AND(Q_Din <= "1011111010")AND(I_Din >= "1000000001")AND(I_Din <= "1011111010")) THEN
				Dbuff <= "1101";
			ELSIF ((Q_Din >= "0000001100")AND(Q_Din <= "0100000110")AND(I_Din >= "1000000001")AND(I_Din <= "1011111010")) THEN
				Dbuff <= "1110";
			ELSIF ((Q_Din >= "0100000111")AND(Q_Din <= "1000000000")AND(Q_Din >= "1000000001")AND(Q_Din <= "1011111010")) THEN
				Dbuff <= "1111";
			END IF;			
				
		END PROCESS;
		
	PROCESS(Dbuff(0), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			Dout(0) <= Dbuff(0); 
			END IF; 
	END PROCESS;
	
	PROCESS(Dbuff(1), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			Dout(1) <= Dbuff(1); 
			END IF; 
	END PROCESS;

	PROCESS(Dbuff(2), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			Dout(2) <= Dbuff(2); 
			END IF; 
	END PROCESS;

	PROCESS(Dbuff(3), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			Dout(3) <= Dbuff(3); 
			END IF; 
	END PROCESS;
	
END LogicFunction;