-- 4bit dez to 10bit I & Q encoder 

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY ten_bit_IQenc IS 

	PORT(Din :IN  STD_LOGIC_VECTOR(3 DOWNTO 0);
		 Clk :IN STD_LOGIC;
		 I_Dout:OUT STD_LOGIC_VECTOR(9 DOWNTO 0);
		 Q_Dout:OUT STD_LOGIC_VECTOR(9 DOWNTO 0));
		 
END ten_bit_IQenc;

ARCHITECTURE LogicFunction OF ten_bit_IQenc IS
	
	SIGNAL I_Dbuff:STD_LOGIC_VECTOR(9 DOWNTO 0);
	SIGNAL Q_Dbuff:STD_LOGIC_VECTOR(9 DOWNTO 0);
	
BEGIN
	
	PROCESS(Din)
		BEGIN
			CASE Din is
				WHEN "0000" => I_Dbuff <= "0010001001";
							   Q_Dbuff <= "1101111000"; 
				WHEN "0001" => I_Dbuff <= "0010001001";
							   Q_Dbuff <= "1001111110"; 
				WHEN "0010" => I_Dbuff <= "0010001001";
							   Q_Dbuff <= "0010001001";
				WHEN "0011" => I_Dbuff <= "0010001001"; 
							   Q_Dbuff <= "0110000100";
				WHEN "0100" => I_Dbuff <= "0110000100";
							   Q_Dbuff <= "1101111000";
				WHEN "0101" => I_Dbuff <= "0110000100";
							   Q_Dbuff <= "1001111110";
				WHEN "0110" => I_Dbuff <= "0110000100";
							   Q_Dbuff <= "0010001001";
				WHEN "0111" => I_Dbuff <= "0110000100";
							   Q_Dbuff <= "0110000100";
				WHEN "1000" => I_Dbuff <= "1101111000";
							   Q_Dbuff <= "1101111000";
				WHEN "1001" => I_Dbuff <= "1101111000";
							   Q_Dbuff <= "1001111110";
				WHEN "1010" => I_Dbuff <= "1101111000";
							   Q_Dbuff <= "0010001001";
				WHEN "1011" => I_Dbuff <= "1101111000";
							   Q_Dbuff <= "0110000100";
				WHEN "1100" => I_Dbuff <= "1001111110"; 
							   Q_Dbuff <= "1101111000";
				WHEN "1101" => I_Dbuff <= "1001111110";
							   Q_Dbuff <= "1001111110";
				WHEN "1110" => I_Dbuff <= "1001111110";
							   Q_Dbuff <= "0010001001";
				WHEN "1111" => I_Dbuff <= "1001111110";
							   Q_Dbuff <= "0110000100";
			END CASE;
		END PROCESS;
	
-- I Latch			
	PROCESS(I_Dbuff(0), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			I_Dout(0) <= I_Dbuff(0); 
			END IF; 
	END PROCESS;
	
	PROCESS(I_Dbuff(1), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			I_Dout(1) <= I_Dbuff(1); 
			END IF; 
	END PROCESS;

	PROCESS(I_Dbuff(2), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			I_Dout(2) <= I_Dbuff(2); 
			END IF; 
	END PROCESS;

	PROCESS(I_Dbuff(3), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			I_Dout(3) <= I_Dbuff(3); 
			END IF; 
	END PROCESS;

	PROCESS(I_Dbuff(4), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			I_Dout(4) <= I_Dbuff(4); 
			END IF; 
	END PROCESS;

	PROCESS(I_Dbuff(5), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			I_Dout(5) <= I_Dbuff(5); 
			END IF; 
	END PROCESS;

	PROCESS(I_Dbuff(6), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			I_Dout(6) <= I_Dbuff(6); 
			END IF; 
	END PROCESS;

	PROCESS(I_Dbuff(7), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			I_Dout(7) <= I_Dbuff(7); 
			END IF; 
	END PROCESS;

	PROCESS(I_Dbuff(8), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			I_Dout(8) <= I_Dbuff(8); 
			END IF; 
	END PROCESS;

	PROCESS(I_Dbuff(9), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			I_Dout(9) <= I_Dbuff(9); 
			END IF; 
	END PROCESS;
	
-- Q Latch

	PROCESS(Q_Dbuff(0), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			Q_Dout(0) <= Q_Dbuff(0); 
			END IF; 
	END PROCESS;
	
	PROCESS(Q_Dbuff(1), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			Q_Dout(1) <= Q_Dbuff(1); 
			END IF; 
	END PROCESS;

	PROCESS(Q_Dbuff(2), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			Q_Dout(2) <= Q_Dbuff(2); 
			END IF; 
	END PROCESS;

	PROCESS(Q_Dbuff(3), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			Q_Dout(3) <= Q_Dbuff(3); 
			END IF; 
	END PROCESS;

	PROCESS(Q_Dbuff(4), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			Q_Dout(4) <= Q_Dbuff(4); 
			END IF; 
	END PROCESS;

	PROCESS(Q_Dbuff(5), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			Q_Dout(5) <= Q_Dbuff(5); 
			END IF; 
	END PROCESS;

	PROCESS(Q_Dbuff(6), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			Q_Dout(6) <= Q_Dbuff(6); 
			END IF; 
	END PROCESS;

	PROCESS(Q_Dbuff(7), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			Q_Dout(7) <= Q_Dbuff(7); 
			END IF; 
	END PROCESS;

	PROCESS(Q_Dbuff(8), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			Q_Dout(8) <= Q_Dbuff(8); 
			END IF; 
	END PROCESS;

	PROCESS(Q_Dbuff(9), Clk) 
		BEGIN 
			IF(Clk = '1') THEN 
			Q_Dout(9) <= Q_Dbuff(9); 
			END IF; 
	END PROCESS;
	
	
END LogicFunction;